# frozen_string_literal: true

require 'json'
require 'pathname'
module IrcLB
  class Config
    def initialize
      @filename = Pathname.new(Dir.home).join('.irclb.json')
      begin
        @config = JSON.parse(IO.read(@filename))
      rescue Errno::ENOENT => e
        puts "Was not able to load #{@filename}."
        exit(1)
      end
    end

    attr_reader :config
  end
end
$config = IrcLB::Config.new.config
